/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { DependencyProperty } from "igniteui-react-core/ES5/DependencyProperty";
import { TrendLineType_$type } from "igniteui-react-core/ES5/TrendLineType";
import { Brush } from "igniteui-react-core/ES5/Brush";
import { PenLineCap_$type } from "igniteui-react-core/ES5/PenLineCap";
import { DoubleCollection } from "igniteui-react-core/ES5/DoubleCollection";
import { List$1 } from "igniteui-react-core/ES5/List$1";
import { AxisRange } from "./AxisRange";
import { CategoryFrame } from "./CategoryFrame";
import { Type, Number_$type, typeCast, enumGetBox, EnumUtil, runOn, markType } from "igniteui-react-core/ES5/type";
import { Rect } from "igniteui-react-core/ES5/Rect";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { CategorySeries } from "./CategorySeries";
import { NotImplementedException } from "igniteui-react-core/ES5/NotImplementedException";
import { Path } from "igniteui-react-core/ES5/Path";
import { PropertyMetadata } from "igniteui-react-core/ES5/PropertyMetadata";
import { isNaN_ } from "igniteui-react-core/ES5/number";
import { PathGeometry } from "igniteui-react-core/ES5/PathGeometry";
import { GeometryGroup } from "igniteui-react-core/ES5/GeometryGroup";
import { Pool$1 } from "igniteui-react-core/ES5/Pool$1";
import { LineGeometry } from "igniteui-react-core/ES5/LineGeometry";
import { Extensions } from "igniteui-react-core/ES5/Extensions";
import { IndicatorRenderer } from "./IndicatorRenderer";
/**
 * @hidden
 */
var FinancialIndicator = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialIndicator, _super);
    function FinancialIndicator() {
        var _this = _super.call(this) || this;
        _this._indicatorColumn = null;
        _this.pb = null;
        _this.l4 = new CategoryFrame(3);
        _this.l6 = new CategoryFrame(3);
        _this.l3 = new CategoryFrame(3);
        _this.indicatorColumn = new List$1(Number_$type, 0);
        _this.pb = new AxisRange(-100, 100);
        return _this;
    }
    FinancialIndicator.prototype.bf = function () {
        return new FinancialIndicatorView(this);
    };
    FinancialIndicator.prototype.im = function (a) {
        _super.prototype.im.call(this, a);
        this.pc = a;
    };
    FinancialIndicator.prototype.po = function (a) {
        if (this.mm != null && !this.mm.ck()) {
            this.i6(true);
        }
    };
    FinancialIndicator.prototype.pg = function (a, b, c) {
        if (isNaN_(b.x) || isNaN_(b.y)) {
            return false;
        }
        var d = this.mm;
        var e = 0;
        if (d != null) {
            e = d.d8(d.j7);
        }
        if ((a.y >= e && a.y <= b.y) || (a.y <= e && a.y >= b.y)) {
            return true;
        }
        return false;
    };
    FinancialIndicator.prototype.bd = function () {
        if (this.be == 0) {
            return 1;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    FinancialIndicator.prototype.ln = function (a) {
        if (this.l1 == null || this.mm == null) {
            return Rect.empty;
        }
        var b = this.k9(a);
        var c = this.bi.bs;
        var d = this.bi.br;
        var e = this.getEffectiveViewport1(this.bi);
        var f = new ScalerParams(0, c, d, this.mm.b8, e);
        f.b = this.ee();
        var g = this.aj(this.l1, this.l3.f, this.ny(this.bi), this.n0(this.bi), a, true);
        if (g == null) {
            return Rect.empty;
        }
        var h = g[0];
        var i = g[1];
        var j = Math.abs(b.x - h[0]);
        var k = Math.abs(b.x - i[0]);
        var l = this.mm.dt(this.mm.j7, f);
        var m = 1;
        if (j < k) {
            var n = h[0] - 0.5 * m;
            var o = h[1];
            var p = l;
            return new Rect(0, n, Math.min(o, p), m, Math.max(o, p) - Math.min(o, p));
        }
        else {
            var q = i[0] - 0.5 * m;
            var r = i[1];
            var s = l;
            return new Rect(0, q, Math.min(r, s), m, Math.max(r, s) - Math.min(r, s));
        }
    };
    FinancialIndicator.prototype.dg = function (a, b) {
        var c = this.le(this.lh(a), true, false);
        if (this.pd == 1) {
            if (this.pg(a, c, b)) {
                return true;
            }
        }
        if (this.pd == 1 || this.pd == 0) {
            if (this.df(a, b)) {
                return true;
            }
        }
        if (this.pd == 2) {
            if (this.dj(a, b)) {
                return true;
            }
        }
        return false;
    };
    FinancialIndicator.prototype.hs = function (a, b, c, d) {
        _super.prototype.hs.call(this, a, b, c, d);
        if (this.l1 != null && typeCast(ISortingAxis_$type, this.l1) !== null) {
            this.l1.i$i();
        }
        if (this.pc.b4) {
            this.pc.b2.g$e(a, b, c, d);
        }
        if (d != null && this.nd.containsKey(d)) {
            var e = this.nd.tryGetValue(d, d);
            d = e.p1;
        }
        if (this.l1 != null && typeCast(ISortingAxis_$type, this.l1) !== null) {
            a = 4;
            b = 0;
            c = this.bz.count;
        }
        switch (a) {
            case 3:
                if (this.pf(b, c, d)) {
                    this.pq(b, c, d);
                    this.po(true);
                }
                break;
            case 2:
                if (this.pf(b, this.bz.count - b, d)) {
                    this.pq(b, this.bz.count - b, d);
                    this.po(true);
                }
                break;
            case 1:
                if (this.pf(b, this.bz.count - b, d)) {
                    var f = new Array(c);
                    for (var g = 0; g < c; g++) {
                        f[g] = 0;
                    }
                    this.indicatorColumn.s(b, f);
                    this.pq(b, this.bz.count - b, d);
                    this.po(true);
                }
                break;
            case 0:
                if (this.pf(b, this.bz.count - b, d)) {
                    this.indicatorColumn.v(b, c);
                    this.pq(b, this.bz.count - b, d);
                    this.po(true);
                }
                break;
            case 4:
                if (this.pf(b, this.bz.count - b, d)) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.bz.count);
                    var h = new Array(c);
                    for (var i = 0; i < c; i++) {
                        h[i] = 0;
                    }
                    this.indicatorColumn.s(0, h);
                    this.pq(b, this.bz.count - b, d);
                    this.po(true);
                }
                break;
        }
    };
    Object.defineProperty(FinancialIndicator.prototype, "p1", {
        get: function () {
            return this.c(FinancialIndicator.pr);
        },
        set: function (a) {
            this.h(FinancialIndicator.pr, a);
        },
        enumerable: true,
        configurable: true
    });
    FinancialIndicator.prototype.pl = function () {
        return -1;
    };
    Object.defineProperty(FinancialIndicator.prototype, "indicatorColumn", {
        get: function () {
            return this._indicatorColumn;
        },
        set: function (a) {
            this._indicatorColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialIndicator.prototype.is = function (a, b, c, d) {
        switch (b) {
            case "XAxis":
                this.pc.ca();
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.pc.b2 = CategoryTrendLineManagerFactory.a(this.pc.b2, this.l1, this.jq, this, this.b2);
                }
                break;
        }
        _super.prototype.is.call(this, a, b, c, d);
        if (this.pc.b4 && this.pc.b2.g$b(a, b, c, d)) {
            this.i6(false);
            var f = typeCast(FinancialIndicatorView.$, this.bh);
            if (f != null && f.b4) {
                f.b2.g$b(a, b, c, d);
            }
            this.ic();
        }
        switch (b) {
            case "FastItemsSource":
                if (this.bz != null) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.bz.count);
                    var g = new Array(this.bz.count);
                    for (var h = 0; h < this.bz.count; h++) {
                        g[h] = 0;
                    }
                    this.indicatorColumn.s(0, g);
                    this.pq(0, this.bz.count, null);
                    if (this.mm != null && !this.mm.ck()) {
                        this.mh.bu.e(this.er);
                        this.i6(false);
                    }
                }
                break;
            case "TrendLineBrush":
                this.jh();
                break;
            case FinancialIndicator.$$p[0]:
                this.hp(true, this.bi);
                this.i6(false);
                this.ic();
                break;
            case "OpenColumn":
            case "HighColumn":
            case "LowColumn":
            case "CloseColumn":
            case "VolumeColumn":
                if (this.bz != null) {
                    if (this.indicatorColumn.count != this.bz.count) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.bz.count);
                        var i = new Array(this.bz.count);
                        for (var j = 0; j < this.bz.count; j++) {
                            i[j] = 0;
                        }
                        this.indicatorColumn.s(0, i);
                    }
                    if (this.pf(0, this.bz.count - 1, b)) {
                        this.pp();
                    }
                }
                break;
            case "XAxis":
                if (this.l1 != null && (typeCast(ISortingAxis_$type, this.l1) !== null || typeCast(ISortingAxis_$type, c) !== null)) {
                    this.pp();
                }
                break;
            case "YAxis":
            case FinancialIndicator.$$p[1]:
                this.pp();
                this.ic();
                break;
            case "TrendLineType":
                this.ic();
                break;
        }
    };
    FinancialIndicator.prototype.ek = function (a, b, c) {
        if (this.indicatorColumn == null) {
            return _super.prototype.ek.call(this, a, b, c);
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.ns(this.bi.bs, this.bi.br, d);
        var f = new ScalerParams(0, this.bi.bs, this.bi.br, this.l1.b8, d);
        f.c = this.bs.m3;
        return this.em(this.indicatorColumn, a, this.l1, f, e, runOn(this, this.nr), b, c);
    };
    FinancialIndicator.prototype.fb = function (a, b) {
        if (this.indicatorColumn == null) {
            return _super.prototype.fb.call(this, a, b);
        }
        return this.fc(a, b, this.l1, runOn(this, this.nr), this.indicatorColumn);
    };
    FinancialIndicator.prototype.e9 = function (a, b) {
        if (this.indicatorColumn == null) {
            return _super.prototype.e9.call(this, a, b);
        }
        return this.fa(a, b, this.l1, runOn(this, this.nr), this.indicatorColumn);
    };
    FinancialIndicator.prototype.get_du = function () {
        return true;
    };
    FinancialIndicator.prototype.pf = function (a, b, c) {
        if (c == null) {
            return true;
        }
        if (this.ph(a, b).contains(c)) {
            return true;
        }
        return false;
    };
    FinancialIndicator.prototype.pq = function (a, b, c) {
        this.pe(a, b);
    };
    FinancialIndicator.prototype.an = function (a) {
        if (this.bz == null) {
            return null;
        }
        if (a != null && a == this.mm) {
            return this.pb;
        }
        return null;
    };
    FinancialIndicator.prototype.c8 = function (a) {
        var b = this.bz != null ? this.bz.indexOf(a) : -1;
        var c = this.bi.bs;
        c = c.copy();
        var d = this.bi.br;
        var e = new Rect(0, 0, 0, 1, 1);
        var f = this.ll(this.bi);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.l1 != null) {
                var g = new ScalerParams(0, e, e, this.l1.b8, f);
                var h = this.l1.dt(b, g);
                if (h < c.left + 0.1 * c.width) {
                    h = h + 0.4 * c.width;
                }
                if (h > c.right - 0.1 * c.width) {
                    h = h - 0.4 * c.width;
                }
                c.x = h - 0.5 * c.width;
            }
            if (this.mm != null && this.indicatorColumn != null && b < this.indicatorColumn.count) {
                var i = new ScalerParams(0, e, e, this.mm.b8, f);
                i.b = this.ee();
                var j = this.mm.dt(this.indicatorColumn._inner[b], i);
                if (j < c.top + 0.1 * c.height) {
                    j = j + 0.4 * c.height;
                }
                if (j > c.bottom - 0.1 * c.height) {
                    j = j - 0.4 * c.height;
                }
                c.y = j - 0.5 * c.height;
            }
            this.bn.ap(this.bs, c, true);
        }
        return b >= 0;
    };
    FinancialIndicator.prototype.dv = function (a, b, c) {
        var d = _super.prototype.dv.call(this, a, b, c);
        if (this.indicatorColumn == null || this.indicatorColumn.count == 0) {
            d = false;
        }
        return d;
    };
    FinancialIndicator.prototype.os = function (a, b) {
        var _this = this;
        _super.prototype.os.call(this, a, b);
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.l1;
        var g = this.mm;
        var h = new ScalerParams(0, c, d, f.b8, e);
        var i = new ScalerParams(0, c, d, g.b8, e);
        i.b = this.ee();
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = 0;
        var k = typeCast(ISortingAxis_$type, this.l1);
        if (k != null && k.i$b.count != this.bz.count) {
            return;
        }
        j = this.ns(c, d, e);
        var l = this.pl();
        if (l == -1) {
            l = this.trendLinePeriod;
        }
        var m = typeCast(FinancialIndicatorView.$, b);
        if (m.b4) {
            m.b2.prepareLineCore(a.p, this.trendLineType, this.indicatorColumn, l, function (n) { return _this.l1.dt(n, h); }, function (n) { return _this.mm.dt(n, i); }, ((function () {
                var $ret = new TrendResolutionParams();
                $ret.c = b.bu.b;
                $ret.d = b.bu.c;
                $ret.e = b.bu.d;
                $ret.a = j;
                $ret.b = _this.er;
                $ret.f = d;
                $ret.g = c;
                return $ret;
            })()));
        }
        var n = this.l1.dw(2, h) - this.l1.dw(1, h);
        for (var o = b.bu.c; o <= b.bu.d; ++o) {
            var p = void 0;
            if (k == null) {
                p = b.bu.getBucket(o);
            }
            else {
                var q = k.i$b._inner[o];
                var r = k.i$d(q);
                var s = this.indicatorColumn._inner[o];
                var t = s;
                var u = r;
                while (o < b.bu.d) {
                    q = k.i$b._inner[o + 1];
                    u = k.i$d(q);
                    if (u - r > n) {
                        break;
                    }
                    o++;
                    var v = this.indicatorColumn._inner[o];
                    s = Math.min(s, v);
                    t = Math.max(t, v);
                }
                var w = NaN;
                if (!isNaN_(r)) {
                    w = this.l1.dt(r, h);
                }
                p = [w, s, t];
            }
            if (!isNaN_(p[0])) {
                if (this.l1 != null && typeCast(ISortingAxis_$type, this.l1) !== null) {
                    p[0] = p[0] + j;
                }
                else {
                    p[0] = f.dt(p[0], h) + j;
                }
                p[1] = g.dt(p[1], i);
                if (b.bu.b > 1 || k != null) {
                    p[2] = g.dt(p[2], i);
                }
                else {
                    p[2] = p[1];
                }
                a.f.add(p);
            }
        }
        return;
    };
    FinancialIndicator.prototype.hp = function (a, b) {
        _super.prototype.hp.call(this, a, b);
        var c = b;
        c.b5(a);
        if (c.b4) {
            c.b2.g$d();
        }
    };
    FinancialIndicator.prototype.ma = function () {
        switch (this.pd) {
            case 1: return 1;
            case 2: return 1;
            case 0: return 12;
        }
        return 1;
    };
    FinancialIndicator.prototype.ou = function (a, b) {
        _super.prototype.ou.call(this, a, b);
        var c = typeCast(FinancialIndicatorView.$, b);
        var d = function (e) { return a.f._inner[e][0]; };
        var e = function (f) { return a.f._inner[f][1]; };
        if (c.b4) {
            c.b2.g$d();
            c.b2.g$g(a.p);
        }
        var f = b.br;
        var g = this.getEffectiveViewport1(b);
        var h = 0;
        var i = this.kw;
        var j = this.o7;
        if (b.bx(a)) {
            c.b5(false);
            if (a.f.count > 0) {
                switch (this.pd) {
                    case 0:
                        var k = CategorySeries.mu(a.f, a.f.count - 1, f, b.bs, false);
                        c.b9(a.f.count, d, e, true, k);
                        break;
                    case 1:
                        if (this.mm != null) {
                            h = this.nw(b);
                        }
                        else {
                            h = 0.5 * (f.top + f.bottom);
                        }
                        var l = CategorySeries.mu(a.f, a.f.count - 1, f, b.bs, false);
                        c.b7(a.f.count, d, e, true, h, l);
                        break;
                    case 2:
                        h = this.nw(b);
                        c.b8(a.f.count, d, e, true, h);
                        break;
                    default: throw new NotImplementedException(0);
                }
            }
            b.bz(a);
        }
        var m = a.f;
        var n = this.bz.count;
        this.l9.x(this, this.m9(), this.l1, runOn(this, this.lt), this.ny(b), this.n0(b));
        var o = false;
        var p = this.l9.c;
        if (p != null) {
            o = true;
        }
        this.l9.al = i;
        this.l9.ah = i;
        if (o) {
            var q = new ScalerParams(0, b.bs, b.br, this.l1.b8, g);
            this.l9.f = false;
            this.or(m, -1, n, this.l1, q, b.n);
        }
        this.l9.ae(c.cr, true, false, true, false);
        this.l9.ae(c.ct, true, false, true, false);
        this.l9.ae(c.cs, false, true, false, false);
        c.cs._opacity = 0.8 * this.l9.i * this.d3;
        this.l9.ae(c.cq, true, false, false, false);
        this.l9.al = j;
        this.l9.ah = j;
        if (o) {
            var r = new ScalerParams(0, b.bs, b.br, this.l1.b8, g);
            this.l9.f = true;
            this.or(m, -1, n, this.l1, r, b.n);
        }
        this.l9.ae(c.cn, true, false, true, false);
        this.l9.ae(c.cp, true, false, true, false);
        this.l9.ae(c.co, false, true, false, false);
        c.co._opacity = 0.8 * this.l9.i * this.d3;
        this.l9.ae(c.cm, true, false, false, false);
        c.cb();
    };
    FinancialIndicator.prototype.jh = function () {
        _super.prototype.jh.call(this);
        if (this.fe < 0) {
            return;
        }
        if (this.pc.b4) {
            this.pc.cc();
        }
    };
    FinancialIndicator.prototype.pp = function () {
        if (this.pc.b4) {
            this.pc.b2.g$i();
        }
        this.pe(0, this.indicatorColumn.count);
        if (this.mm != null && !this.mm.ck()) {
            this.i6(false);
        }
    };
    FinancialIndicator.prototype.hy = function (a) {
        _super.prototype.hy.call(this, a);
        this.a2.exportTrendlineData(this, a, this.pc.b2.g$j);
    };
    FinancialIndicator.$t = markType(FinancialIndicator, 'FinancialIndicator', FinancialSeries.$, [ITrendLineSeries_$type]);
    FinancialIndicator.pr = DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialIndicator.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    return FinancialIndicator;
}(FinancialSeries));
export { FinancialIndicator };
Type.dep(DependencyProperty, PropertyMetadata, FinancialIndicator, 'raisePropertyChanged', ['DisplayType:pd:ps', [IndicatorDisplayType_$type, enumGetBox(IndicatorDisplayType_$type, 0)], 'IgnoreFirst:pj:pt', [1, 0], 'TrendLineType::pz', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::py', [1, 1.5], 'TrendLinePeriod::px', [1, 7], 'TrendLineBrush::pu', [Brush.$, null], 'TrendLineZIndex:pk:p0', [1, 1001], 'TrendLineDashArray:p2:pv', [DoubleCollection.$], 'TrendLineDashCap:p3:pw', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
/**
 * @hidden
 */
var FinancialIndicatorBucketCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialIndicatorBucketCalculator, _super);
    function FinancialIndicatorBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    FinancialIndicatorBucketCalculator.prototype.getBucket = function (a) {
        var b = a * this.b;
        var c = Math.min(b + this.b - 1, this.f.b0.indicatorColumn.count - 1);
        var d = NaN;
        var e = NaN;
        for (var f = b; f <= c; ++f) {
            var g = this.f.b0.indicatorColumn._inner[f];
            if (!isNaN_(d)) {
                if (!isNaN_(g)) {
                    d = Math.min(d, g);
                    e = Math.max(e, g);
                }
            }
            else {
                d = g;
                e = g;
            }
        }
        if (!isNaN_(d)) {
            return [0.5 * (b + c), d, e];
        }
        return [NaN, NaN, NaN];
    };
    FinancialIndicatorBucketCalculator.$t = markType(FinancialIndicatorBucketCalculator, 'FinancialIndicatorBucketCalculator', FinancialBucketCalculator.$);
    return FinancialIndicatorBucketCalculator;
}(FinancialBucketCalculator));
export { FinancialIndicatorBucketCalculator };
/**
 * @hidden
 */
var FinancialIndicatorView = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialIndicatorView, _super);
    function FinancialIndicatorView(a) {
        var _this = _super.call(this, a) || this;
        _this.b0 = null;
        _this.b3 = null;
        _this.cr = ((function () {
            var $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        _this.cn = ((function () {
            var $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        _this.cs = ((function () {
            var $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        _this.co = ((function () {
            var $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        _this.ct = ((function () {
            var $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        _this.cp = ((function () {
            var $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        _this.cq = ((function () {
            var $ret = new Path();
            $ret.aj = new GeometryGroup();
            return $ret;
        })());
        _this.cm = ((function () {
            var $ret = new Path();
            $ret.aj = new GeometryGroup();
            return $ret;
        })());
        _this.b1 = null;
        _this.cj = new Path();
        _this.cl = new Path();
        _this.ck = new Path();
        _this.ci = new Path();
        _this.cf = new Path();
        _this.ch = new Path();
        _this.cg = new Path();
        _this.ce = new Path();
        _this.b0 = a;
        _this.b3 = ((function () {
            var $ret = new Pool$1(LineGeometry.$);
            $ret.create = runOn(_this, _this.cd);
            $ret.destroy = runOn(_this, _this.b6);
            return $ret;
        })());
        return _this;
    }
    FinancialIndicatorView.prototype.bv = function () {
        return new FinancialIndicatorBucketCalculator(this);
    };
    FinancialIndicatorView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.bw.o7 = ((function () {
                var $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.bw.ev = 2;
        }
    };
    FinancialIndicatorView.prototype.cd = function () {
        return new LineGeometry();
    };
    FinancialIndicatorView.prototype.b6 = function (a) {
    };
    Object.defineProperty(FinancialIndicatorView.prototype, "b2", {
        get: function () {
            if (this.b1 == null) {
                this.b1 = CategoryTrendLineManagerFactory.a(this.b1, this.e.ap(), this.e.jq, this.e, this.e.b2);
            }
            return this.b1;
        },
        set: function (a) {
            this.b1 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialIndicatorView.prototype, "b4", {
        get: function () {
            return this.b1 != null;
        },
        enumerable: true,
        configurable: true
    });
    FinancialIndicatorView.prototype.b5 = function (a) {
        Extensions.e(this.cr.aj);
        Extensions.e(this.cs.aj);
        Extensions.e(this.ct.aj);
        Extensions.e(this.cn.aj);
        Extensions.e(this.co.aj);
        Extensions.e(this.cp.aj);
        Extensions.d(this.cq.aj);
        Extensions.d(this.cm.aj);
        if (a) {
            this.b3.count = 0;
        }
        this.an();
    };
    FinancialIndicatorView.prototype.cb = function () {
    };
    FinancialIndicatorView.prototype.b9 = function (a, b, c, d, e) {
        IndicatorRenderer.g(a, b, c, d, this.bs, this.br, this.cr, this.cn, this.bu.b, this.e.er, e);
        this.an();
    };
    FinancialIndicatorView.prototype.b7 = function (a, b, c, d, e, f) {
        IndicatorRenderer.e(a, b, c, d, this.bs, this.br, this.cr, this.cs, this.cn, this.co, e, this.bu.b, this.e.er, f);
        this.an();
    };
    FinancialIndicatorView.prototype.b8 = function (a, b, c, d, e) {
        IndicatorRenderer.f(a, b, c, d, this.br, e, this.b3, this.cq, this.cm);
        this.an();
    };
    FinancialIndicatorView.prototype.cc = function () {
        this.b0.p1 = null;
        if (this.b0.trendLineBrush != null) {
            this.b0.p1 = this.b0.trendLineBrush;
        }
        else {
            this.b0.p1 = this.b0.kw;
        }
    };
    FinancialIndicatorView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.cj.aj = this.cr.aj;
        this.cl.aj = this.ct.aj;
        this.ck.aj = this.cs.aj;
        this.ci.aj = this.cq.aj;
        this.cf.aj = this.cn.aj;
        this.ch.aj = this.cp.aj;
        this.cg.aj = this.co.aj;
        this.ce.aj = this.cm.aj;
        this.cj._stroke = a;
        this.cl._stroke = a;
        this.cj.ac = this.e.ev + 3;
        this.cl.ac = this.e.ev + 3;
        this.ck._fill = a;
        this.ck._opacity = 1;
        this.ci._stroke = a;
        this.ci.ac = this.e.ev + 3;
        this.cf._stroke = a;
        this.ch._stroke = a;
        this.cf.ac = this.e.ev + 3;
        this.ch.ac = this.e.ev + 3;
        this.cg._fill = a;
        this.cg._opacity = 1;
        this.ce._stroke = a;
        this.ce.ac = this.e.ev + 3;
    };
    FinancialIndicatorView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            if (b) {
                if (this.b0.pd == 2) {
                    a.s(this.ci);
                    a.s(this.ce);
                }
                else {
                    a.s(this.ck);
                    a.s(this.cj);
                    a.s(this.cl);
                    a.s(this.cg);
                    a.s(this.cf);
                    a.s(this.ch);
                }
            }
            else {
                if (this.b0.pd == 2) {
                    a.s(this.cq);
                    a.s(this.cm);
                }
                else {
                    a.s(this.cs);
                    a.s(this.cr);
                    a.s(this.ct);
                    a.s(this.co);
                    a.s(this.cn);
                    a.s(this.cp);
                }
            }
        }
    };
    FinancialIndicatorView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (this.b0.trendLineType != 0 && !b) {
                var c = this.b2.g$j;
                c.ac = this.b0.trendLineThickness;
                c._stroke = this.b0.p1;
                c.ad = this.b0.p3;
                c.ai = this.b0.p2;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    FinancialIndicatorView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.cq, "positiveColumnsShape", ["Positive", "Main"]);
        this.e.a2.exportPathData(a, this.cm, "negativeColumnsShape", ["Negative"]);
        this.e.a2.exportPathData(a, this.cr, "positive0", ["Positive", "Main"]);
        this.e.a2.exportPathData(a, this.ct, "positive1", ["Positive"]);
        this.e.a2.exportPathData(a, this.cs, "positive01", ["PositiveFill"]);
        this.e.a2.exportPathData(a, this.cn, "negative0", ["Negative", "Main"]);
        this.e.a2.exportPathData(a, this.cp, "negative1", ["Negative"]);
        this.e.a2.exportPathData(a, this.co, "negative01", ["NegativeFill"]);
    };
    FinancialIndicatorView.prototype.ca = function () {
        if (this.b4) {
            this.b1 = CategoryTrendLineManagerFactory.a(this.b1, this.e.ap(), this.e.jq, this.e, this.e.b2);
        }
    };
    FinancialIndicatorView.$t = markType(FinancialIndicatorView, 'FinancialIndicatorView', FinancialSeriesView.$);
    return FinancialIndicatorView;
}(FinancialSeriesView));
export { FinancialIndicatorView };
